|char *GetDEVersionString(DATA_EXT *extptr asm("a0"));

.data
.include "os.h"
.globl GetDEVersionString
GetDEVersionString:
 pea.l (%a0)
 moveq.l #2,%d0 |DE_VERSION_STRING
 jbsr SearchDataExtension
 move.l %a0,%d0
 beq.s 0f |version string not found
 pea.l (%a2) |save %a2
 movea.l 0xc8:w,%a2
 pea.l (%a0) |push src for strcpy
 pea.l (%a0) |push argument for strlen, prepare space for dest for strcpy
 movea.l strlen*4(%a2),%a0
 jsr (%a0)
 addq.l #1,%d0 |add 1 for the '\0'
 move.l %d0,-(%a7) |push size for HeapAllocPtr
 movea.l HeapAllocPtr*4(%a2),%a0
 jsr (%a0)
 addq.l #4,%a7 |pop size for HeapAllocPtr
 move.l %a0,12(%a7) |replace saved extptr with return value
 beq.s 1f |not enough memory
 move.l %a0,(%a7) |pass dest for strcpy
 movea.l strcpy*4(%a2),%a0
 jsr (%a0) |copy the string
1:
 addq.l #8,%a7 |pop strcpy src and dest
 movea.l (%a7)+,%a2 |restore %a2
 movea.l (%a7)+,%a0 |return value 
 rts
0:
 movea.l (%a7)+,%a0
 moveq.l #3,%d0 |DE_VERSION_NUMBER
 jbsr SearchDataExtension
 move.l %a0,%d0
 beq.s 2f |version number not found - return NULL
 movem.l %d3-%d6/%a2,-(%a7) |save %d3-%d6 and %a2
 clr.w %d3 |zero-extend the version numbers
 move.w %d3,%d4
 move.w %d3,%d5
 move.w %d3,%d6
 move.b (%a0)+,%d3 |major
 move.b (%a0)+,%d4 |minor
 move.b (%a0)+,%d5 |revision
 move.b (%a0)+,%d6 |subrev
 pea.l 16:w
 movea.l 0xc8:w,%a2
 movea.l HeapAllocPtr*4(%a2),%a0
 jsr (%a0)
 move.l %a0,(%a7)
 beq.s 3f |not enough memory
 movem.w %d3-%d6,-(%a7) |push version numbers
 pea.l format(%PC) |push format string
 pea.l (%a0) |push buffer
 movea.l sprintf*4(%a2),%a0
 jsr (%a0)
 lea.l 16(%a7),%a7 |pop arguments
3:
 movea.l (%a7)+,%a0 |return value 
 movem.l (%a7)+,%d3-%d6/%a2 |restore %d3-%d6 and %a2
2:
 rts

format: .asciz "%u.%u.%u.%u"
