|char *GetDEVersionStringAndNumberThrow(DATA_EXT *extptr asm("a0"));

.data
.include "os.h"
.globl GetDEVersionStringAndNumberThrow
GetDEVersionStringAndNumberThrow:
 move.l %d7,-(%a7) |save %d7
 pea.l (%a0)
 moveq.l #2,%d0 |DE_VERSION_STRING
 jbsr SearchDataExtension
 move.l %a0,%d7
 beq.w 0f |version string not found
 movea.l (%a7),%a0
 moveq.l #3,%d0 |DE_VERSION_NUMBER
 jbsr SearchDataExtension
 move.l %a0,%d0
 beq.s 4f |version number not found
 movem.l %d3-%d6/%a2,-(%a7) |save %d3-%d6 and %a2
 clr.w %d3 |zero-extend the version numbers
 move.w %d3,%d4
 move.w %d3,%d5
 move.w %d3,%d6
 move.b (%a0)+,%d3 |major
 move.b (%a0)+,%d4 |minor
 move.b (%a0)+,%d5 |revision
 move.b (%a0)+,%d6 |subrev
 movem.w %d3-%d6,-(%a7) |push version numbers for sprintf
 move.l %d7,-(%a7) |push src for sprintf
 pea.l formatex(%PC) |push format string for sprintf
 movea.l 0xc8:w,%a2
 move.l %d7,-(%a7) |push argument for strlen, prepare space for buffer for sprintf
 movea.l strlen*4(%a2),%a0
 jsr (%a0)
 moveq.l #19,%d1
 add.l %d1,%d0 |add 19 for " (255.255.255.255)" and for the '\0'
 movea.l %d0,%a0 |pass size for HeapAllocPtrThrow
 jbsr HeapAllocPtrThrow
 move.l %a0,40(%a7) |replace saved extptr with return value
 move.l %a0,(%a7) |pass buffer for sprintf
 movea.l sprintf*4(%a2),%a0
 jsr (%a0) |format the string
 lea.l 20(%a7),%a7 |pop sprintf arguments
 movem.l (%a7)+,%d3-%d6/%a2 |restore %d3-%d6 and %a2
 movea.l (%a7)+,%a0 |return value 
 move.l (%a7)+,%d7 |restore %d7 
 rts
4:
 pea.l (%a2) |save %a2
 movea.l 0xc8:w,%a2
 move.l %d7,-(%a7) |push src for strcpy
 move.l %d7,-(%a7) |push argument for strlen, prepare space for dest for strcpy
 movea.l strlen*4(%a2),%a0
 jsr (%a0)
 addq.l #1,%d0 |add 1 for the '\0'
 movea.l %d0,%a0 |pass size for HeapAllocPtrThrow
 jbsr HeapAllocPtrThrow
 move.l %a0,12(%a7) |replace saved extptr with return value
 move.l %a0,(%a7) |pass dest for strcpy
 movea.l strcpy*4(%a2),%a0
 jsr (%a0) |copy the string
 addq.l #8,%a7 |pop strcpy src and dest
 movea.l (%a7)+,%a2 |restore %a2
 movea.l (%a7)+,%a0 |return value 
 move.l (%a7)+,%d7 |restore %d7 
 rts
0:
 movea.l (%a7)+,%a0
 moveq.l #3,%d0 |DE_VERSION_NUMBER
 jbsr SearchDataExtension
 move.l %a0,%d0
 beq.s 2f |version number not found - return NULL
 movem.l %d3-%d6,-(%a7) |save %d3-%d6
 clr.w %d3 |zero-extend the version numbers
 move.w %d3,%d4
 move.w %d3,%d5
 move.w %d3,%d6
 move.b (%a0)+,%d3 |major
 move.b (%a0)+,%d4 |minor
 move.b (%a0)+,%d5 |revision
 move.b (%a0)+,%d6 |subrev
 lea.l 16:w,%a0
 jbsr HeapAllocPtrThrow
 move.l %a0,-(%a7)
 movem.w %d3-%d6,-(%a7) |push version numbers
 pea.l format(%PC) |push format string
 pea.l (%a0) |push buffer
 movea.l 0xc8:w,%a0
 movea.l sprintf*4(%a0),%a0
 jsr (%a0)
 lea.l 16(%a7),%a7 |pop arguments
 movea.l (%a7)+,%a0 |return value 
 movem.l (%a7)+,%d3-%d6 |restore %d3-%d6
2:
 move.l (%a7)+,%d7 |restore %d7 
 rts

format: .asciz "%u.%u.%u.%u"
formatex: .asciz "%s (%u.%u.%u.%u)"
